Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.value
Class DateValue

    java.lang.Object
      net.sf.saxon.value.Value
          net.sf.saxon.value.AtomicValue
              net.sf.saxon.value.CalendarValue
                  net.sf.saxon.value.DateValue

All Implemented Interfaces:
  java.lang.Comparable, Expression, Item, java.io.Serializable, ValueRepresentation

Direct Known Subclasses:
  GDayValue, GMonthDayValue, GMonthValue, GYearMonthValue, GYearValue

public class DateValue
extends CalendarValue
implements java.lang.Comparable

A value of type Date. Note that a Date may include a TimeZone, and unlike the situation with dateTime, the timezone is part of the value space.

See Also:
  Serialized Form

Field Summary
`protected int` | `tzOffset`

Fields inherited from class net.sf.saxon.value.CalendarValue
`calendar, zoneSpecified`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`protected` | `DateValue()` Default constructor needed for subtyping
`` | `DateValue(java.lang.CharSequence s)` Constructor: create a dateTime value from a supplied string, in ISO 8601 format
`` | `DateValue(java.util.GregorianCalendar calendar, boolean timeZoneSpecified, int timeZoneOffset)` Create a DateValue

Method Summary
`CalendarValue` | `add(DurationValue duration)` Add a duration to a date
`int` | `compareTo(java.lang.Object other)` Compare the value to another date value
`AtomicValue` | `convertPrimitive(BuiltInAtomicType requiredType, boolean validate)` Convert to target data type
`java.lang.Object` | `convertToJava(java.lang.Class target, XPathContext context)` Convert to Java object (for passing to external functions)
`boolean` | `equals(java.lang.Object other)` Compare two (sequence) values for equality.
`AtomicValue` | `getComponent(int component)` Get a component of the value.
`ItemType` | `getItemType()` Determine the data type of the expression
`java.lang.String` | `getStringValue()` Convert to string
`java.util.Date` | `getUTCDate()` Get the UTC date/time corresponding to this dateTime.
`int` | `hashCode()` Return a hash code to support the equals() function
`CalendarValue` | `removeTimezone()` Return a dateTime with the same localized value, but without the timezone component
`void` | `setDateValue(DateValue d)` Set the value (used for creating subtypes)
`void` | `setLexicalValue(java.lang.CharSequence s)`
`CalendarValue` | `setTimezone(SecondsDurationValue tz)` Return a date, time, or dateTime with the same normalized value, but in a different timezone
`SecondsDurationValue` | `subtract(CalendarValue other, XPathContext context)` Determine the difference between two points in time, as a duration

Methods inherited from class net.sf.saxon.value.AtomicValue
`checkPermittedContents, convert, convert, display, effectiveBooleanValue, evaluateAsString, evaluateItem, getCardinality, getImplementationMethod, getLength, getPrimitiveValue, getStringValueCS, getTypedValue, hasBuiltInType, iterate, process, toString`

Methods inherited from class net.sf.saxon.value.Value
`analyze, asItem, asValue, collapseWhitespace, convert, convertJavaObjectToXPath, getDependencies, getIterator, getParentExpression, getSpecialProperties, itemAt, iterateSubExpressions, makeQNameValue, normalizeWhitespace, promote, simplify, stringToNumber, trimWhitespace`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### tzOffset

    protected int tzOffset

Constructor Detail

### DateValue

    protected DateValue()

  Default constructor needed for subtyping

### DateValue

    public DateValue(java.lang.CharSequence s)
              throws XPathException

  Constructor: create a dateTime value from a supplied string, in ISO 8601 format

### DateValue

    public DateValue(java.util.GregorianCalendar calendar,
                     boolean timeZoneSpecified,
                     int timeZoneOffset)

  Create a DateValue

Parameters:
  `calendar` - the absolute date/time value
  `timeZoneSpecified` - true if there is a timezone
  `timeZoneOffset` - the timezone offset from UTC in minutes

Method Detail

### setLexicalValue

    public void setLexicalValue(java.lang.CharSequence s)
                         throws XPathException

  Throws:
    `XPathException`

### getUTCDate

    public java.util.Date getUTCDate()

  Get the UTC date/time corresponding to this dateTime. This normalizes the value to incorporate the timezone information, for example 2002-01-01T07:00:00-05:00 gives the same answer as 2002-01-01T12:00:00Z

### convertPrimitive

    public AtomicValue convertPrimitive(BuiltInAtomicType requiredType,
                                        boolean validate)

  Convert to target data type

  Specified by:
    `convertPrimitive` in class `AtomicValue`
  Parameters:
    `requiredType` - an integer identifying the required atomic type
    `validate` - true if validation is required. If set to false, the caller guarantees that the value is valid for the target data type, and that further validation is therefore not required. Note that a validation failure may be reported even if validation was not requested.
  Returns:
    an AtomicValue, a value of the required type; or an ErrorValue

### setDateValue

    public void setDateValue(DateValue d)

  Set the value (used for creating subtypes)

### getStringValue

    public java.lang.String getStringValue()

  Convert to string

  Specified by:
    `getStringValue` in interface `Item`
  Specified by:
    `getStringValue` in class `AtomicValue`
  Returns:
    ISO 8601 representation.

### getItemType

    public ItemType getItemType()

  Determine the data type of the expression

  Specified by:
    `getItemType` in interface `Expression`
  Overrides:
    `getItemType` in class `Value`
  Returns:
    Type.DATE,

### removeTimezone

    public CalendarValue removeTimezone()
                                 throws XPathException

  Return a dateTime with the same localized value, but without the timezone component

  Specified by:
    `removeTimezone` in class `CalendarValue`
  Returns:
    the result of removing the timezone
  Throws:
    `XPathException`

### setTimezone

    public CalendarValue setTimezone(SecondsDurationValue tz)
                              throws XPathException

  Return a date, time, or dateTime with the same normalized value, but in a different timezone

  Specified by:
    `setTimezone` in class `CalendarValue`
  Returns:
    the date/time in the new timezone
  Throws:
    `XPathException`

### convertToJava

    public java.lang.Object convertToJava(java.lang.Class target,
                                          XPathContext context)
                                   throws XPathException

  Convert to Java object (for passing to external functions)

  Overrides:
    `convertToJava` in class `Value`
  Throws:
    `XPathException`

### getComponent

    public AtomicValue getComponent(int component)
                             throws XPathException

  Get a component of the value. Returns null if the timezone component is requested and is not present.

  Overrides:
    `getComponent` in class `AtomicValue`
  Throws:
    `XPathException`

### compareTo

    public int compareTo(java.lang.Object other)

  Compare the value to another date value

  Specified by:
    `compareTo` in interface `java.lang.Comparable`
  Parameters:
    `other` - The other date value. Must be an object of class DateValue.
  Returns:
    negative value if this one is the earlier, 0 if they are chronologically equal, positive value if this one is the later. For this purpose, dateTime values with an unknown timezone are considered to be UTC values (the Comparable interface requires a total ordering).
  Throws:
    `java.lang.ClassCastException` - if the other value is not a DateValue (the parameter is declared as Object to satisfy the Comparable interface)

### equals

    public boolean equals(java.lang.Object other)

  Description copied from class: `Value`
  Compare two (sequence) values for equality. This supports identity constraints in XML Schema, which allow list-valued elements and attributes to participate in key and uniqueness constraints. This method returns false if any error occurs during the comparison, or if any of the items in either sequence is a node rather than an atomic value.

  Overrides:
    `equals` in class `Value`

### hashCode

    public int hashCode()

  Description copied from class: `Value`
  Return a hash code to support the equals() function

  Overrides:
    `hashCode` in class `Value`

### add

    public CalendarValue add(DurationValue duration)
                      throws XPathException

  Add a duration to a date

  Specified by:
    `add` in class `CalendarValue`
  Parameters:
    `duration` - the duration to be added (may be negative)
  Returns:
    the new date
  Throws:
    `XPathException` - if the duration is an xs:duration, as distinct from a subclass thereof

### subtract

    public SecondsDurationValue subtract(CalendarValue other,
                                         XPathContext context)
                                  throws XPathException

  Determine the difference between two points in time, as a duration

  Overrides:
    `subtract` in class `CalendarValue`
  Parameters:
    `other` - the other point in time
    `context` -
  Returns:
    the duration as an xdt:dayTimeDuration
  Throws:
    `XPathException` - for example if one value is a date and the other is a time

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD